// Persistence of Vision Ray Tracer Scene Description File
// File: ?.pov
// Vers: 3.1
// Desc: Basic Scene Example
// Date: mm/dd/yy
// Auth: ?[esp]
//


#include "colors.inc"
background { color White }


// >>> T_Stone26 (from File "stones2.inc") <<<

// Constants from file "colors.inc"
#declare Clear = rgbf 1;

#declare Zold= texture {
  pigment {
    granite
    rotate y*90
    color_map {
      [0.4 color PaleGreen ]
      [0.7 color PaleGreen ]
      [0.9 color Gray30]
     
              }
    
    frequency 6
    rotate <0, 10, 0>
    scale .5
          }
       normal {
              granite .3 
              scale .5
           } 
       }
           
#declare Kek= texture {
  pigment {
    granite
    rotate y*90
    color_map {
      [0.2 color SkyBlue ]
      [0.6 color Gray30]
     
              }
    frequency 6
    rotate <0, 10, 0>
    scale .5
           }                                
    normal {
              granite .3 
              scale .5
           }
           }

#declare Piros= texture {
  pigment {
    granite
    rotate y*90
    color_map {
      [0.6 color Red ]
      [0.9 color Gray30]
     
              }
    frequency 6
    rotate <0, 10, 0>
    scale .5
           }                                
    normal {
              granite .3 
              scale .5
           }  
           }
#macro settex(Color)
 texture {
  pigment {
    granite
    rotate y*90
    color_map {
      [0.8 color Color ]
      [0.9 color Gray30]
     
              }
    frequency 6
    rotate <0, 10, 0>
    scale .5
           }                                
    normal {
              granite .3 
              scale .5
           }  
           }

#end
#declare Texs = array[10]
#declare i=0;
#while (i<10)
 #declare col=i/20 + .5;
 #declare Texs[i]=settex(< col, col , col > )
 #declare i=i+1;
#end
camera
{
  location  <0.0, 7.5, .0>
  look_at   <0.0, 0.0,  0.0>
}
  /*
camera
{
  location  <0.0, 4.5, -4>
  look_at   <0.0, 0.0,  0.0>
}
    */
light_source
{
  <-7,4,2>
  color White  // light's color
   area_light <4,0,4>, <0,4,0> 5,5
   adaptive 1
   jitter
  
}

light_source
{
  <0,12,0>
  color White  // light's color
  fade_distance 10 fade_power 2
  shadowless
}

#macro padlo(num)
#declare R1=seed(5);
#declare i=0;
union{
 #while (i<num)
  sphere{
           0 , 1 
           scale <.5 * rand(R1) +.2 , .5 * rand(R1) +.2 , .5 * rand(R1) +.2 >
           rotate < 360* rand(R1) ,360* rand(R1) ,360* rand(R1) >          
           translate <10 * rand(R1) - 5 , .5 * rand(R1) , 8* rand(R1) - 4 >
           texture { Texs[int (10*rand(R1) ) ]  }
         }
  #declare i=i+1;
 #end
      }
#end


#declare KekSmiley=
union{  
sphere { 0, 1 scale<3, 2 , 2 > texture { Kek }} 
sphere { <-1.5,1.6,.35> , .35 texture { Piros }   } 
sphere { <1.5,1.6,.35> , .35 texture { Piros }   }
sphere { <0,2,0>, .4 texture { Piros } }

union {
     #declare i=-70;
      #while ( i <= 70 )
       sphere { <0 , .6, .8 > .09 rotate < -90, i ,0>  texture { Piros }  }
      #declare i=i+5;
      #end
     scale <3,2,2>
      }


scale .7  
scale <1,.5,1>
rotate <0,15,0>
translate <-1.8,.7,-1>
      }

#declare ZoldSmiley=  
union{  
sphere { 0, 2  texture { Zold }} 

sphere { <0,1.8,0> .4  texture { Piros } rotate <30 ,-70,0>  }
sphere { <0,1.8,0> .4  texture { Piros } rotate <30 ,70,0>  }
sphere { <0,1.8,0> .5  texture { Piros } rotate <0 ,-15,0>  }
     #declare i=-60;
      #while ( i <= 60 )
       sphere { <0 , 1.8, .8 > .1 rotate < -65+4*sin(radians(30*i)), i ,0>  texture { Piros }  }
      #declare i=i+3;
      #end
/*#declare i=0;
      #while ( i <= 70 )
       
       cylinder { <0,0,2>, <0,0,3.5> , .1 rotate < 0,i,0> texture { Piros }  }
      #declare i=i+10;
      #end     
           */
    scale <1.5,.5,1>  
    scale .6
    rotate <0,-15,0>
    translate <1.8,.5,1>
      }
padlo(900)
KekSmiley
ZoldSmiley